#COMPILE EXE                                    
#DIM ALL
#INCLUDE "win32api.inc"           
'#INCLUDE "debug.inc"                      

'This program finds file and folders, searching over specified folders.                   
'Just specify the name of the file or folder, or any part of it.                            
'If the name is without an extension then filenames without extensions are tested 
'All files and folders matching the specified name are listed in a listbox.                 
'any found file can be double clicked to open it in Windows Explorer.
                                                                              
'ver 1.10 (01-04-2016)                                                  
' - correction: enabled Back button when 'None found'
' - removed 'Make New Folder' button from DISPLAY BROWSE
'ver 1.20 (01-19-2016)
' - improved stop, while searching folders and files
' - eliminate possible repitions of 'application data'
'ver 1.30 (02-01-2016)  
' - corrected search algorithm to use only fn, the found file or folder
' - added checkbox for including folders and exact expression
' - added options for partial name, exact name, exact word
' - changed mouse pointer while hovering over Stop button
' - show number found
' - print list of items found
'ver 1.40 (03-26-2017)
' - added Window minimize button at rhs of title bar
' - added help button on main window
' - added compound searches with "*" and "|"
'   ... text1 * text2 searches for files containing both text1 and text2
'   ... text1 | text2 searches for files containing text1 or text2
'ver 1.41 (04-05-2017)
' - corrected bug with searching part of name being inside of path name 
'ver 1.42 (05-04-2017)
' - corrected error checking extension with compound searches 
'ver 1.50 (05-06-2017) pending 
' - added option to list file size and date modified
' - added option to sort on size or date
' - changed Files-only checkbox to two checkboxes, Files and Folders
' - programmed ENTER (or double click) to open files found in Explorer
'ver 1.51 (05-11-2017)
' - programmed ESC (or ALT+F4) to close files opened by this program
'ver 1.52 (05-26-2017) 
' - removed exact word option
' - exact name must include the extension if file                           
' - disabled exact name option for compound searches
'ver 1.53 (07-26-2017)
' - removed back and exit buttons in favor of close system button
' - for folder searches, search only the end folder
'ver 1.54 (08-21-2017) pending
' - corrected problem when both files and folders are checked (added found1, found2)
'ver 1.60 (01/12/2018)
' - [Begin search] for new search, [Last search] before any new search is specified
' - allow option to add exception folders
'ver 1.61 (05/09/2019)
' - add checkbox: track folders searched --> "trackingLog.txt"
'ver 1.62 (06/18/2019)                                                                
' - prohibit path in name of file to find
' - kill trackingLog.txt at begin search to prohibit accumulated entries
'ver 1.63 (11/27/2019)
' - fixed bug that took path to search from exception folders
' - folders found include any matching that specified, not just the end folder
'ver 1.64 (01/01/2021)
' - Stop button used to stop and continue searching as desired
' - system exit closes the found list screen and stops all background searching
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'Notes
'find files matching "sName.sExt"                                                   
' - the sName can be matched partially, exactly, or by word
' - if specified, the sExt must be matched exactly            
                          
$ver = "1.64"

'%LB_SETHORIZONTALEXTENT= &H194                  
%ID_Find         = 101                                                                                         
%ID_Files        = 102
%ID_Folders      = 103
%ID_FileSizes    = 104
%ID_FileDates    = 105                                                                
%ID_PartName     = 111
%ID_ExactName    = 112              
%ID_SrchFolders  = 121                                    
%ID_ExcpFolders  = 122
%ID_SrchList     = 123                   
%ID_AddSrch      = 124
%ID_DelSrch      = 125
%ID_Begin        = 130
%ID_Help         = 131
%ID_Tracking     = 132        
%ID_FoundList    = 201
%ID_Start        = 202
%ID_AsFound      = 203                
%ID_BySize       = 204
%ID_ByDate       = 205
%ID_Stop         = 211
%ID_Print        = 212
%ID_Done         = 221
%ID_Status       = 222
                                                                                                                
UNION FileTimeQuad   
  ft AS FILETIME     
  qq AS QUAD                                
END UNION                                          
                                                                                    
global hDlg, hShow, maxLen, start, hdc, stopSrch, mSrch, nSrch, nFound, nCount, lastOptions as long
global srchFiles, srchFolders, fileSizes, fileDates, partName, exactName, folders, stopPtr as long
global hFoundList, gOldWindowProc, enterKey, escapeKey, ghKbdHook, tracking, trackLog as long
global folderSrch, numSrchFolders, numExcpFolders, continue as long
global sName, sExt, srch1, srch2, sLast as string
global attr, asFound1(), asFound2(), bySize(), byDate() as dword
global doFolders(), notFolders(), foundItems() as string
                   
FUNCTION PBMAIN()                                                              
   local nStyle as long 
   local s as string
   DIALOG FONT "arial", 10
   nStyle = %ws_sysmenu or %WS_MINIMIZEBOX
   DIALOG NEW 0, "Find Files & Folders - Ver " + $ver, , , 300, 245, nStyle TO hDlg
   control add label, hDlg, -1, "Find: ", 7, 23, 25, 12
   control add textbox, hDlg, %ID_Find, "", 25, 22, 115, 13
   control add option, hDlg, %ID_PartName, "Part of name", 150, 22, 60, 12, %ws_tabstop or %ws_group
   control add option, hDlg, %ID_ExactName, "Exact name", 150, 35, 60, 12
   control add checkbox, hDlg, %ID_Files, "Files", 220, 10, 50, 15, %WS_tabstop or %ws_group
   control add checkbox, hDlg, %ID_Folders, "Folders", 220, 22, 50, 15, %WS_tabstop
   control add checkbox, hDlg, %ID_FileSizes, "File Sizes", 220, 34, 50, 15, %WS_tabstop                      
   control add checkbox, hDlg, %ID_FileDates, "File Dates", 220, 46, 60, 15, %WS_tabstop
   control add option, hDlg, %ID_SrchFolders, "Search folders", 25, 58, 60, 10                        
   control add option, hDlg, %ID_ExcpFolders, "Except folders", 90, 58, 60, 10 
   nStyle = %WS_VSCROLL or %WS_BORDER
   CONTROL ADD LISTBOX, hDlg, %ID_SrchList, , 25, 70, 245, 100, nStyle, %WS_EX_CLIENTEDGE
   control add frame, hDlg, -1, "Search folders", 35, 170, 120, 37
   control add button, hDlg, %ID_AddSrch, "&Add", 45, 182, 45, 18
   control add button, hDlg, %ID_DelSrch, "&Del", 95, 182, 45, 18
   control add button, hDlg, %ID_Begin, "&Begin", 180, 178, 40, 22
   control add button, hDlg, %ID_Help, "&Help", 222, 178, 40, 22                                                        
   s = "Track folders searched (usefull when medium is corrupted)" 
   control add checkbox, hDlg, %ID_Tracking, s, 25, 210, 220, 15, %WS_tabstop
   DIALOG SHOW MODAL hDlg, CALL mainDlgProc
END FUNCTION     
                                                                                                  
CALLBACK FUNCTION mainDlgProc()
   local s, s1, s2, srch as string
   local i, n, nSel, options as long                                                 
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG                                                      
         dim doFolders(1 to 32), notFolders(1 to 32)
         numSrchFolders = 1: doFolders(1) = "C:\"
         listbox add cb.hndl, %ID_SrchList, doFolders(1)              
         'numExcpFolders = 1: notFolders(1) = "c:\windows.old\"
         CONTROL SET OPTION cb.hndl, %ID_PartName, %ID_PartName, %ID_ExactName
         control set check cb.hndl, %ID_Files, 1                                                    
         control set check cb.hndl, %ID_Folders, 1
         CONTROL SET OPTION cb.hndl, %ID_SrchFolders, %ID_SrchFolders, %ID_ExcpFolders
         ghKbdHook = SetWindowsHookEx(%WH_KEYBOARD, CODEPTR(KeyboardHook), 0, GetCurrentThreadID)
      CASE %WM_COMMAND
         if cb.ctl = %ID_Find then
            if cb.ctlmsg = %EN_change then
               control get text cb.hndl, %ID_Find to s
               if instr(s, any "*|") then                                                  
                  control set option cb.hndl, %ID_PartName, %ID_PartName, %ID_ExactName
                  control disable cb.hndl, %ID_ExactName
               else
                  control enable cb.hndl, %ID_ExactName
               end if
            end if
         elseif cb.ctl = %ID_SrchFolders then                                     
            folderSrch = 0
            listbox reset cb.hndl, %ID_SrchList
            for i = 1 to numSrchFolders
               listbox add cb.hndl, %ID_SrchList, doFolders(i)
            next i
         elseif cb.ctl = %ID_ExcpFolders then
            folderSrch = -1      
            listbox reset cb.hndl, %ID_SrchList                                
            for i = 1 to numExcpFolders
               listbox add cb.hndl, %ID_SrchList, notFolders(i)
            next i
         elseif cb.ctl = %ID_AddSrch then
            IF CB.CTLMSG = %BN_CLICKED OR CB.CTLMSG = 1 THEN
               s = "Choose folder to search"
               DISPLAY BROWSE CB.HNDL, , , s, "C:\", %BIF_NONEWFOLDERBUTTON TO srch
               IF LEN(srch) THEN 'adding a folder to search
                  folders = 1
                  srch = RTRIM$(srch, "\") + "\"
                  listbox add cb.hndl, %ID_SrchList, srch
                  if folderSrch < 0 then 'adding exception folder
                     incr numExcpFolders
                     notFolders(numExcpFolders) = lcase$(srch)
                  else 'adding search folder
                     incr numSrchFolders
                     doFolders(numSrchFolders) = srch
                  end if
                  control enable cb.hndl, %ID_Begin
               END IF
            END IF
         elseif cb.ctl = %ID_DelSrch then
            listbox get select cb.hndl, %ID_SrchList to nSel
            if nSel then 'remove folder from search
               if folderSrch < 0 then 'deleting exception folder
                  array delete notFolders(nSel)
                  decr numExcpFolders
               else 'deleting search folder
                  array delete doFolders(nSel)
                  decr numSrchFolders
               end if   
               folders = 1
               listbox delete cb.hndl, %ID_SrchList, nSel
            end if
         elseif cb.ctl = %ID_Help then
            s = "Program searches for files and folders" + $crlf _
              + "boolean searches with '*' (AND) or '|' (OR)" + $crlf _
              + "... used only with part of name searches" + $crlf _
              + "Part of name: search for part of a file or folder name" + $crlf _
              + "... can include extension (with period)" + $crlf _ 
              + "... can also include a boolean search such as: 'HR' * 'Block'" + $crlf _
              + "Exact name: search for exact file or folder name" + $crlf _
              + "... the exact name may or may not include the extension" + $crlf _
              + "Exact word: search for file or folder with exact word in name" + $crlf _
              + "Files: checked to search for files" + $crlf _ 
              + "Folders: checked to search for folders" + $crlf _
              + "File sizes: include file sizes in Kilobytes" + $crlf _ 
              + "File dates: include last date that file was modified" + $crlf _                            
              + "Add folders to list for searching" + $crlf _                       
              + "Delete folders from searching list" + $crlf _ 
              + "Track folders searched: use when medium may be corrupted" + $crlf _ 
              + "Begin search button beins the search for all file/folder matches," + $crlf _ 
              + "listing them as they are found on a new screen" + $crlf _
              + "Stop button is used to stop and Continue the search as desired." + $crlf _                       
              + "Enter or Double clicking a found file displays it in Explorer" + $crlf _
              + "... another double click executes a program associated with it" + $crlf _
              + "... ESC or ALT+F4 closes files opened from Explorer and returns" + $crlf _                       
              + "to the found list screen where the search can be resumed." + $crlf _ 
              + "System Exit closes the found list screen and stops bkgd searching" + $crlf _  
              + $crlf
           msgbox s, %mb_iconquestion, "Program Help"                                   
         elseif cb.ctl = %ID_Files and cb.ctlmsg = %bn_clicked then   
            control get check cb.hndl, cb.ctl to n
            if n then                                     
               control enable cb.hndl, %ID_FileSizes
               control enable cb.hndl, %ID_FileDates
            else
               control disable cb.hndl, %ID_FileSizes
               control disable cb.hndl, %ID_FileDates
            end if
         elseIF CB.CTL = %ID_Begin then 
            control get text cb.hndl, %ID_Find to s: s = lcase$(s): srch1 = s 
            if len(s) = 0 then exit function
            if instr(srch1, "\") then
               s = "Path not permitted in file to find"
               msgbox s, %MB_iconerror, "Filename Error"
               control set text cb.hndl, %ID_Find, parse$(srch1, "\", -1)
               control set focus cb.hndl, %ID_Find: exit function
            end if                                                                            
            sName = pathname$(name, s): sExt = pathname$(extn, s)
            mSrch = instr(s, "*")
            nSrch = instr(s, "|")       
            if (mSrch or nSrch) then 'filtered search 
               control set option hDlg, %ID_PartName, %ID_PartName, %ID_ExactName
               n = instr(s, any "*|")
               if n then 
                  srch1 = trim$(left$(s, n-1))
                  srch2 = trim$(mid$(s, n+1))                
               end if
               if len(srch1) = 0 or len(srch2) = 0 or instr(srch2, any "*|") then
                  msgbox "Illegal filter search", %MB_iconerror, "Filter error"
                  CONTROL SEND cb.hndl, %ID_Find, %EM_SETSEL, 0, -1
                  control set focus cb.hndl, %ID_Find: exit function                         
               end if  
            end if                                                     
            srchFiles = 0: exactName = 0
            control get check cb.hndl, %ID_PartName to PartName                                                   
            control get check cb.hndl, %ID_ExactName to exactName
            control get check cb.hndl, %ID_Files to srchFiles 
            control get check cb.hndl, %ID_Folders to srchFolders
            control get check cb.hndl, %ID_FileSizes to fileSizes
            control get check cb.hndl, %ID_FileDates to fileDates
            control get check cb.hndl, %ID_Tracking to tracking                    
            if tracking then
               kill "trackingLog.txt"
               trackLog = freefile
               OPEN "trackingLog.txt" FOR append AS #trackLog
               print# trackLog, "Tracked folders which were read"
               close #trackLog                                                                                      
            end if

            listbox get count cb.hndl, %ID_SrchList to nCount                                               
            if nCount = 0 then 'default search path                                                   
               nCount = 1: listbox add cb.hndl, %ID_SrchList, "C:\"
            end if 
                                                                                  
            nFound = 0: continue = 0                                                         
            showFiles()
         end if                                                     
      case %WM_Destroy
         UnhookWindowsHookEx ghKbdHook
      CASE %WM_SYSCOMMAND                                  
         IF CB.CTL = %SC_CLOSE THEN
            dialog end hDlg                                                             
         end if
   end select            
end function   
                
sub showFiles()
   'this sub lists the files and folders as they are found
   'also sorts the files for size and date if specified
   '-----------------------------------------------------------------------------
   local nStyle as long
   local s as string
   'nStyle = %WS_DLGFRAME 
   nStyle = %WS_CAPTION OR %WS_POPUP OR %WS_SYSMENU OR %DS_MODALFRAME
   s = "Matching Files"
   if srchFiles = 0 then s = s + " and Folders"                 
   DIALOG NEW hDlg, s, , , 400, 320, nStyle TO hShow
   nStyle = %ws_tabstop or %WS_VSCROLL or %WS_HSCROLL or %LBS_DISABLENOSCROLL or %WS_BORDER
   CONTROL ADD LISTBOX, hShow, %ID_FoundList, , 20, 10, 360, 220, nStyle, %WS_EX_CLIENTEDGE
   'control send hShow, %ID_FoundList, %LBS_DISABLENOSCROLL , 0, 0
   control add option, hShow, %ID_AsFound, "As found", 140, 250, 40, 12, %ws_tabstop or %ws_group 
   control add option, hShow, %ID_BySize, "By size", 140, 262, 40, 12
   control add option, hShow, %ID_ByDate, "By date", 140, 274, 40, 12
   control add frame, hShow, -1, "Sort", 130, 240, 65, 55, %ws_group                 
   control add button, hShow, %ID_Stop, "&Stop", 212, 250, 50, 20, %ws_tabstop
   control add button, hShow, %ID_Print, "&Print", 265, 250, 50, 20, %ws_tabstop 
   control add label, hShow, %ID_Done, "", 25, 250, 100, 20                          
   control add label, hShow, %ID_Status, "", 25, 270, 100, 15                
   if tracking then
      s = "See the file 'trackingLog.txt' for the folders searched"
      control add label, hShow, %ID_Tracking, s, 25, 300, 220, 15
   end if
   DIALOG SHOW MODAL hShow, CALL showFilesProc
end sub

CALLBACK FUNCTION showFilesProc()                                       
   local i, n, k, x, y, hFont, nSel, maxLength, exitFcn as long
   local s, ss, sPath as string
   static mPtr, sortedBySize, sortedByDate, hFoundList as long
   SELECT CASE CB.MSG                                              
      CASE %WM_INITDIALOG 
         font new "MS Sans Serif", 14 to hFont
         control set font cb.hndl, %ID_Done, hFont
         control set option cb.hndl, %ID_AsFound, %ID_AsFound, %ID_ByDate 
         sName = lcase$(sName)
         CONTROL SEND CB.HNDL, %ID_FoundList, %WM_GETFONT, 0, 0 TO hFont
         hdc = GetDC(cb.hndl)
         SelectObject hDC, hFont
         control set size hShow, %ID_FoundList, 360, 220
         control handle cb.hndl, %ID_FoundList to hFoundList
         DIALOG POST CB.HNDL, %WM_COMMAND, %ID_Start, 0
      CASE %WM_SETCURSOR  'Change cursor when hovering over label                       
         IF GetDlgCtrlId(CB.WPARAM) = %ID_Stop THEN
            mouseptr 1: stopPtr = 1 'mouse ptr shows arrow
         else                                                               
            stopPtr = 0                                                                   
         END IF
      case %WM_timer
         'come here every 200ms and look if ESC key pressed
         if GetAsyncKeyState(%VK_ESCAPE) and getFocus <> hFoundList then
            'now send keys Alt+F4 to close any window openened from this program       
            keyBd_Event %VK_MENU, 0, 0, 0
            keybd_event %VK_F4, 0, 0, 0                                 
            keybd_event %VK_F4, 0, %KEYEVENTF_KEYUP, 0
            keyBd_Event %VK_MENU, 0, %KEYEVENTF_KEYUP, 0 
            sleep 200 'give a little delay
         end if
      CASE %WM_COMMAND
         IF CB.CTL = %ID_Start then
            stopSrch = 0
            sortedBySize = 0: sortedByDate = 0
            control get check hDlg, %ID_FileSizes to i
            if i = 0 then control disable cb.hndl, %ID_BySize 
            control get check hDlg, %ID_fileDates to i
            if i = 0 then control disable cb.hndl, %ID_ByDate 
            control enable cb.hndl, %ID_Stop
            CONTROL SET COLOR cb.hndl, %ID_Done, %rgb_red, -1
            control set text cb.hndl, %ID_Done, "Please wait"               
            mouseptr 11 to k  'mouse ptr shows busy
            for i = 1 to numSrchFolders 'search specified folders               
               sPath = doFolders(i): maxLen = 0
               myFindFiles sPath
            next i                                                                                
            CONTROL SET COLOR cb.hndl, %ID_Done, %rgb_GREEn, -1
            control set text cb.hndl, %ID_Done, "Done"
            'control disable cb.hndl, %ID_Stop
            control set text cb.hndl, %ID_Stop, "&Exit"
            stopSrch = 1: mouseptr k  'done with searching, back to prev mouse ptr
            if nFound then
               redim foundItems(1 to nFound) 'listbox found items
               redim asFound1(1 to nFound)   'indexes to foundItems() tagged to bySize()
               redim asFound2(1 to nFound)   'indexes to foundItems() tagged to byDate()
               for i = 1 to nFound                                 
                  listbox get text cb.hndl, %ID_FoundList, i to foundItems(i)                                                  
               next i
               control set focus cb.hndl, %ID_FoundList
               control send cb.hndl, %ID_FoundList, %LB_SETHORIZONTALEXTENT, maxLen+10, 0 
            else         
               listbox add cb.hndl, %ID_FoundList, "None found"
            end if                                                                        
         elseif cb.ctl = %ID_FoundList and nFound then
            LISTBOX GET SELECT cb.hndl, %ID_FoundList TO nSel
            if nSel and (enterKey or cb.ctlmsg = %LBN_DBLCLK) then 'select this item in Windows Explorer 
               listbox get text cb.hndl, %ID_FoundList, nSel to s
               shell "explorer /select, " + s: enterKey = 0
               SetTimer(cb.hndl, 101, 200, 0) 'creates the timer  200ms
            end if
         elseif cb.ctl = %ID_Stop and cb.ctlmsg = %BN_Clicked then 'stop search
            control get text cb.hndl, %ID_Stop to s
            if s = "&Stop" then                                                                        
               stopSrch = 1: continue = 0
               if nFound then
                  redim foundItems(1 to nFound) 'listbox found items
                  redim asFound1(1 to nFound)   'indexes to foundItems() tagged to bySize()
                  redim asFound2(1 to nFound)   'indexes to foundItems() tagged to byDate()
                  for i = 1 to nFound
                     listbox get text cb.hndl, %ID_FoundList, i to foundItems(i)                                                 
                  next i
                  control set focus cb.hndl, %ID_FoundList
                  control send cb.hndl, %ID_FoundList, %LB_SETHORIZONTALEXTENT, maxLen+10, 0
               end if    
               control set text cb.hndl, %ID_Stop, "&Continue"
               control set text cb.hndl, %ID_Done, "Stopped"                                 
            elseif s = "&Continue" then
               continue = 1: stopSrch = 0
               control set text cb.hndl, %ID_Stop, "&Stop"
               control set text cb.hndl, %ID_Done, "Please wait"
            elseif s = "&Exit" then
               dialog end hShow                                                           
            end if
         elseif cb.ctl = %ID_Print and cb.ctlmsg = %BN_clicked then
            printList()   
         elseif cb.ctl = %ID_AsFound and cb.ctlmsg = %BN_clicked then 'orig sort as found
            listbox reset cb.hndl, %ID_FoundList
            for i = 1 to nFound
               listbox add hShow, %ID_FoundList, foundItems(i)
            next i
         elseif cb.ctl = %ID_BySize and cb.ctlmsg = %BN_clicked then 'sort by size
            if sortedBySize = 0 then
               for i = 1 to nFound: asFound1(i) = i: next i                                         
               array sort bySize(), tagarray asFound1()
            end if                                                                  
            listbox reset cb.hndl, %ID_FoundList
            for i = 1 to nFound
               listbox add hShow, %ID_FoundList, foundItems(asFound1(i))
            next i 
            sortedBySize = -1  
         elseif cb.ctl = %ID_ByDate and cb.ctlmsg = %BN_clicked then 'sort by date 
            if sortedByDate = 0 then
               for i = 1 to nFound: asFound2(i) = i: next i
               array sort byDate(), tagarray asFound2()
            end if                                                 
            listbox reset cb.hndl, %ID_FoundList   
            for i = 1 to nFound
               listbox add hShow, %ID_FoundList, foundItems(asFound2(i))
            next i
            sortedByDate = -1   
         end if
      CASE %WM_SYSCOMMAND                                  
         IF CB.CTL = %SC_CLOSE THEN                   
            continue = -1 'no more searching in background
            dialog end hShow                                                            
         end if                                                            
   end select                                                      
end function 

FUNCTION KeyboardHook(BYVAL iCode AS INTEGER, BYVAL wParm AS LONG, BYVAL lParm AS LONG) AS DWORD
   'trap keyboard Return and ESC keys 
   local h as long
   STATIC nCount AS LONG
   IF iCode < 0 THEN
      FUNCTION = CallNextHookEx(ghKbdHook, iCode, wParm, lParm): EXIT FUNCTION
   END IF
   IF iCode <> %HC_ACTION THEN EXIT FUNCTION
   INCR nCount: IF nCount = 2 THEN nCount = 0: EXIT FUNCTION
   SELECT CASE wParm                                                       
   CASE %VK_RETURN                                              
      h = GetParent(GetFocus)
      if h = hDlg then
         dialog send hDlg, %WM_command, %ID_Begin, 0           
      else
         enterKey = 1: dialog send hShow, %WM_command, %ID_FoundList, 0 
      end if
   end select                                              
END FUNCTION                            
                                      
sub myFindFiles(sPath AS STRING)      
   'recursively finds and displays files and folders matching sName, starting from sPath
   'when sName is specified without an extension, then filenames without extensions are compared
   'original code by Casey Sprangel of www.ifxGroup.net, modified extensively by Charles Dietz
   '-------------------------------------------------------------------------------------------------
   local f, s, ss, sx, sn, fn as string
   local i, n, n1, n2, hSearch, found, found1, found2 as long
   local g, r as dword
   local sz AS SIZEL
   local mask AS ASCIIZ * %MAX_PATH
   local ft as FILETIME, q as quad            
   local WFD AS WIN32_FIND_DATA               'find file data structure (WFD for source)
   static FTQuad as FileTimeQuad
                 
   sPath = RTRIM$(sPath, "\") + "\"           'add backslash if not there
   mask = sPath + "*.*"                       'mask lists where and what files to find 
   hSearch = FindFirstFile(mask, WFD)         'get handle of first file found
   IF hSearch = %INVALID_HANDLE_VALUE THEN    'loop through directory for files
      FindClose hSearch: exit sub
   end if
   DO                                               
      DIALOG DOEVENTS 0          
      if stopPtr = 0 then mouseptr 11   'mouse ptr shows busy                                 
      fn = lcase$(WFD.cFileName): found = 0        
      IF fn = "." or fn = ".." THEN iterate
      f = lcase$(sPath) + fn
      sn = lcase$(pathname$(name, fn))                         
      sx = lcase$(pathname$(extn, fn))
      IF BIT(WFD.dwFileAttributes, 4) THEN f = f + "\"
      
      if exactName then                                                                
         if srchFiles and sn = sName and sx = sExt then found = 1                                                    
         if srchFolders then 'search only the end folder
             ss = "\" + f + "\"
             s = "\" + srch1 + "\"              
             if instr(ss, s) then found = 1
         end if
      else 'part of name
         if mSrch or nSrch then
            n1 = 0: n2 = 0                                                                                                       
            if instr(f, srch1) > 0 then n1 = -1
            if instr(f, srch2) > 0 then n2 = -1                            
            if mSrch then found1 = n1 and n2
            if nSrch then found2 = n1 or n2
         else
            if srchFiles then found1 = instr(fn, srch1)
            if srchFolders then 'search only the end folder          
               s = parse$(f, "\", -2): found2 = instr(s, srch1)           
            end if
         end if
         found = found1 or found2
      end if                                                         
      IF BIT(WFD.dwFileAttributes, 4) THEN 'this is a folder
         for i = 1 to numExcpFolders
            if f = notFolders(i) then iterate do
         next i
         s = rtrim$(LCASE$(f), "\") + "\" 
         if tracking then                                                         
            OPEN "trackingLog.txt" FOR append AS #trackLog
            print# trackLog, s
            close #trackLog
         end if
         if err then
            msgbox str$(err)+"   "+error$(errclear) 
            msgbox str$(trackLog)+"   "+s             
            FindClose hSearch 
            close #trackLog
         end if
         if srchFolders and found then                                                
            incr nFound
            listbox add hShow, %ID_FoundList, s
            redim preserve bySize(1 to nFound): bySize(nFound) = 0          
            redim preserve byDate(1 to nFound): byDate(nFound) = 0
            ss = str$(nFound) + " items found"
            control set text hShow, %ID_Status, ss 
            GetTextExtentPoint32 hdc, BYVAL STRPTR(s), BYVAL LEN(s), sz
            maxLen = max(maxLen, sz.cx)                                           
         end if
         if stopSrch then 'searching was stopped 
            do until continue <> 0: DIALOG DOEVENTS 0: loop 
         end if
         if continue = -1 then FindClose hSearch: exit sub 
         myFindFiles s
      ELSE 'this is a file                                 
         if srchFiles and found then
            incr nFound
            s = sPath + fn
            if fileSizes and WFD.nFileSizeHigh = 0 then 
               redim preserve bySize(1 to nFound)
               g = WFD.nFileSizeLow \ 1024
               r = WFD.nFileSizeLow - 1024 * g
               if r >= 512 then incr g
               g = max(g, 1)                                        
               s = f + "," + str$(g) + " KB"
               bySize(nFound) = g
            end if   
            if fileDates then
               ft = WFD.ftLastWriteTime
               FTQuad.ft = ft: q = FTQuad.qq
               s = s + ", " + FileTimeConvert(q)
            end if
            listbox add hShow, %ID_FoundList, s
            ss = str$(nFound) + " items found"
            control set text hShow, %ID_Status, ss
            GetTextExtentPoint32 hdc, BYVAL STRPTR(s), BYVAL LEN(s), sz
            maxLen = max(maxLen, sz.cx)                                     
         end if
      END IF                                                       
      if stopSrch then 'searching was stopped
         do until continue <> 0: DIALOG DOEVENTS 0: loop 
      end if
      if continue = -1 then FindClose hSearch: exit sub   
   LOOP WHILE FindNextFile(hSearch, WFD)
   FindClose hSearch
   'close #trackLog 
END sub

FUNCTION FileTimeConvert(BYVAL q AS QUAD) as string
'Created: 11/Apr/2002 by Matthew Berg
   local nA, nB, nC, nD, nE, nM, nJulianDay AS DWORD
   local d, m, y as dword 
   local day, mo, yr as string
 
   'Perform conversion calculations
   nJulianDay = q \ 864000000000&& + 2305814??? 
   nA = nJulianDay + 32044
   nB = ( 4 * nA + 3 ) \ 146097
   nC = nA - ( 146097 * nB ) \ 4
   nD = ( 4 * nC + 3 ) \ 1461
   nE = nC - ( 1461 * nD ) \ 4
   nM = ( 5 * nE + 2 ) \ 153
 
   'Return date components in function arguments
   d = nE - ( 153 * nM + 2 ) \ 5 + 1
   m = nM + 3 - 12 * ( nM \ 10 )
   y = 100 * nB + nD - 4800 + ( nM \ 10 )
   redim preserve byDate(1 to nFound)
   byDate(nFound) = d + m * 100 + y * 10000
   day = format$(d, "00")
   mo = format$(m, "00")
   yr = format$(y, "0000")
   FUNCTION = mo + "/" + day + "/" + yr
END FUNCTION                                                                                                  

sub printList()
   local i, n, prWi, hdc1, maxLines, lineCount as long
   local x, y as single
   local title, s as string
   local sz AS SIZEL
   title = "List of found files and folders"
   XPRINT ATTACH CHOOSE using %PD_PAGENUMS or %PD_Allpages
   XPRINT GET ATTACH TO s: if len(s) = 0 then exit sub 'printer not connected
   XPRINT FONT "MS Sans Serif", 9, 0
   XPRINT GET clip To x, y  'x = printable width in pixels
   XPRINT GET DC TO hdc1
   XPRINT GET LINES TO maxLines
   maxLines = maxLines - 4
   lineCount = maxLines
   prWi = x 
   FOR i = 1 to nFound
      IF lineCount = maxLines THEN 'new page - print title
         xprint title
         XPRINT 
         lineCount = 2           
      END IF
      DIALOG DOEVENTS 0
      s = foundItems(i)
      do while len(s)
         n = prLen(hdc1, s, prWi)
         xprint left$(s, n) 
         incr lineCount
         if n = len(s) then exit do
         s = "   " + mid$(s, n+1)
      loop
      IF lineCount = maxLines THEN XPRINT FORMFEED
   next i
   XPRINT CLOSE
end sub

function prLen(hdc1 as long, s as string, prWi as long) as long
   local ss as string
   local sz as SIZEL
   sz.cx = prWi: ss = s
   do
      ss  = left$(ss, int((prWi/sz.cx)*len(ss)))
      GetTextExtentPoint32 hdc1, BYVAL STRPTR(ss), BYVAL LEN(ss), sz
   loop until sz.cx <= prWi
   function = len(ss)  
end function

 